<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;

/**
 * Class ZoznamPoctuKontrolAObratuPodlaSubjektuFakturacie
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolAObratuPodlaSubjektuFakturacie extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @param array $udaje
     *
     * @return self
     */
    public static function createFromArray(array $udaje): self
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(new PocetKontrolPodlaObratuASubjektuFakturacie(
                mb_strtoupper($udaj['subjekt']),
                (float)$udaj['obrat'],
                (int)$udaj['pocet']
            ));
        }

        return $zoznam;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrol $pocetKontrol
     *
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolAObratuPodlaSubjektuFakturacie
     */
    public function add(PocetKontrol $pocetKontrol): self
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolPodlaObratuASubjektuFakturacie) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolPodlaObratuASubjektuFakturacie::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (?PocetKontrolPodlaObratuASubjektuFakturacie &$pocetKontrolPodlaObratuASubjektuFakturacie, int $index) use ($pocetKontrol, &$addNewRecord) {
                if ($pocetKontrolPodlaObratuASubjektuFakturacie->equalsNazovSubjektu($pocetKontrol)) {
                    $pocetKontrolPodlaObratuASubjektuFakturacie = $pocetKontrolPodlaObratuASubjektuFakturacie->navysitPocetAObrat($pocetKontrol);
                    $addNewRecord = false;
                }
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }
}
